//+------------------------------------------------------------------+
//|                                           EasyOrder settings.mq4 |
//|                                                                  |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright ""
#property link      ""
#import "EasyOrder.dll"
int EasyOrder(int hwnd);
//---- input parameters

extern string TradeSettings3="Change hours-1 before & between-3 after";
extern string      TradeHour= "07:00";
extern string      TradeHour1= "10:30";

extern string TradeSettings1="Stop Loss-1 before-2 between-3 after";
extern double        StopLossPips=65;
extern double        StopLossPips1=65;
extern double        StopLossPips2=65;

extern string TradeSettings2="Take Profit-1 before-2 between-3 after";
extern double      TakeProfitPips=65;
extern double      TakeProfitPips1=65;
extern double      TakeProfitPips2=65;

extern string Adjust_Text = "Size and Font";
extern string      TextFont = "Arial"; 
extern int         Text_Size =9;

extern string TradeSettings4="Lines";
extern color       StoplossColor=Lime;
extern color       TakeprofitColor=Lime;
extern int         Width=1;

extern string Adjust_Text_Direction_Hint = "Left:100-/-0:Right - Not working yet";
extern int Adjust_Text_Position =10;

extern string TradeSettings5 = "Box corner / not working";
extern int	       BoxCorner = 0;// Choose which corner to place headlines 0=Upper Left, 1=Upper Right, 2=lower left , 3=lower right

#define MODE_INIT 3
#define MODE_DEINIT 2
#define MODE_NORMAL 1


double pmod;

int         Faktor, Digt, cnt;
double         TPp, SLp;

//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+


int EasyOrder(int hwnd);

string obj;
int i, ticket;


int start()
{
   OrderManager(MODE_NORMAL);
 //  return(0);

      if(Close[0]>10)  {Faktor=1000; Digt=3;}  else
      if(Close[0]<10)  {Faktor=100000; Digt=5;}
      
      if(OrdersTotal()!=0)
         {
         for(cnt=0; cnt<OrdersTotal(); cnt++)
            {
            OrderSelect(cnt,SELECT_BY_POS);
            
  double T1 = StrToTime(TimeToStr(TimeLocal(),TIME_DATE) + " " + TradeHour + ":00");
  double T2 = StrToTime(TimeToStr(TimeLocal(),TIME_DATE) + " " + TradeHour1 + ":00");
            
    //--------------Take Profit--------------------------------

            if(OrderTakeProfit()==0 && TakeProfitPips && TakeProfitPips1 && TakeProfitPips2 !=0)
               {
                  if(OrderType()==OP_BUY && OrderSymbol()==Symbol())
                
                  if ((TimeLocal()<=T1))
                    { TPp = OrderOpenPrice()+TakeProfitPips/Faktor;}
                 else  
                
                 if ((TimeLocal()>=T1)&&(TimeLocal()<=T2))
                     {TPp = OrderOpenPrice()+TakeProfitPips1/Faktor;}
                 else   
             
                 if ((TimeLocal()>=T2)) 
                    {TPp = OrderOpenPrice()+TakeProfitPips2/Faktor;}
                
     //--------------------------------------------------------------------------//         
                     
             if(OrderType()==OP_SELL && OrderSymbol()==Symbol())            
                  
                 if ((TimeLocal()<=T1))        
                    {TPp = OrderOpenPrice()-TakeProfitPips/Faktor;}
                 else    
                      
                 if ((TimeLocal()>=T1)&&(TimeLocal()<=T2))
                    {TPp = OrderOpenPrice()-TakeProfitPips1/Faktor;}
                 else       
                      
                 if ((TimeLocal()>=T2))    
                     {TPp = OrderOpenPrice()-TakeProfitPips2/Faktor;}    
                       
                            
                 } else TPp = OrderTakeProfit();
               
     //--------------Stop Loss-------------------------------------------

            if(OrderStopLoss()==0 && StopLossPips && StopLossPips1 && StopLossPips2 !=0)
               {
                  if(OrderType()==OP_BUY && OrderSymbol()==Symbol())
                  
                  if ((TimeLocal()<=T1))     
                     {SLp = OrderOpenPrice()-StopLossPips/Faktor;}
                     else
                     
                   if ((TimeLocal()>=T1)&&(TimeLocal()<=T2))  
                     {SLp = OrderOpenPrice()-StopLossPips1/Faktor;}
                     else
                     
                   if ((TimeLocal()>=T2))   
                     {SLp = OrderOpenPrice()-StopLossPips2/Faktor;}
                     
     //-----------------------------------------------------------------                
                  if(OrderType()==OP_SELL && OrderSymbol()==Symbol())  
                  
                     if ((TimeLocal()<=T1))                  
                     {SLp = OrderOpenPrice()+StopLossPips/Faktor;}
                     else
                     
                     if ((TimeLocal()>=T1)&&(TimeLocal()<=T2)) 
                     {SLp = OrderOpenPrice()+StopLossPips1/Faktor;}
                     else
                     if ((TimeLocal()>=T2)) 
                     {SLp = OrderOpenPrice()+StopLossPips2/Faktor;}
                     
               } else SLp = OrderStopLoss();

    //---------------Modify Order--------------------------
            if (OrderType()==OP_BUY || OrderType()==OP_SELL)   
            OrderModify(OrderTicket(),OrderOpenPrice(),SLp,TPp,0);               
    //-----------------------------------------------------
            
            } // for cnt
         }//if OrdersTotal
  return(0);
  }// Start()
//+------------------------------------------------------------------+
void DeleteGFX(int tickets[]){
   for(int i=ArraySize(tickets)-1;i>=0;i--){
      ObjectDelete(tickets[i]+"-sl");
      ObjectDelete(tickets[i]+"-open");
      ObjectDelete(tickets[i]+"-tp");      
      ObjectDelete(tickets[i]+"-sl_l");
      ObjectDelete(tickets[i]+"-tp_l"); 
   }
}

void UpdateGFX(int tickets[]){
   for(int i=ArraySize(tickets)-1;i>=0;i--){
      OrderSelect(tickets[i],SELECT_BY_TICKET);
      ObjectCreate(tickets[i]+"-sl",OBJ_HLINE,0,0,OrderStopLoss());
      ObjectSet(tickets[i]+"-sl",OBJPROP_WIDTH,Width);
      ObjectSet(tickets[i]+"-sl",OBJPROP_PRICE1,OrderStopLoss());
      ObjectSet(tickets[i]+"-sl",OBJPROP_COLOR,StoplossColor);    
      ObjectCreate(tickets[i]+"-sl_l",OBJ_TEXT,0,OrderOpenTime(),OrderStopLoss());
      ObjectSet(tickets[i]+"-sl_l",OBJPROP_TIME1,OrderOpenTime());
      ObjectSet(tickets[i]+"-sl_l",OBJPROP_PRICE1,OrderStopLoss());
      ObjectSet(tickets[i]+"-sl_l",OBJPROP_COLOR,StoplossColor);  
      ObjectSetText(tickets[i]+"-sl_l","[SL]#"+OrderTicket()+"  for "+DoubleToStr(MathAbs(OrderOpenPrice()-OrderStopLoss())/pmod,1)+" pips",Text_Size, TextFont);  

      ObjectCreate(tickets[i]+"-tp",OBJ_HLINE,0,0,OrderTakeProfit());
      ObjectSet(tickets[i]+"-tp",OBJPROP_WIDTH,Width);
      ObjectSet(tickets[i]+"-tp",OBJPROP_COLOR,TakeprofitColor);   
      ObjectSet(tickets[i]+"-tp",OBJPROP_PRICE1,OrderTakeProfit());
      ObjectCreate(tickets[i]+"-tp_l",OBJ_TEXT,0,OrderOpenTime(),OrderTakeProfit());
      ObjectSet(tickets[i]+"-tp_l",OBJPROP_TIME1,OrderOpenTime());
      ObjectSet(tickets[i]+"-tp_l",OBJPROP_PRICE1,OrderTakeProfit());
      ObjectSet(tickets[i]+"-tp_l",OBJPROP_COLOR,TakeprofitColor);  
      ObjectSetText(tickets[i]+"-tp_l","[TP]#"+OrderTicket()+"  for "+DoubleToStr(MathAbs(OrderOpenPrice()-OrderTakeProfit())/pmod,1)+" pips",Text_Size, TextFont);  


      
      /*ObjectCreate(tickets[i]+"-open",OBJ_HLINE,0,0,OrderOpenPrice());
      ObjectSet(tickets[i]+"-open",OBJPROP_COLOR,OpenPriceColor);      
      ObjectSet(tickets[i]+"-open",OBJPROP_PRICE1,OrderOpenPrice());*/
   }   
}

void RecalcByGFX(int &tickets[],double &sl[], double &tp[]){
   for(int i=ArraySize(tickets)-1;i>=0;i--){
      OrderSelect(tickets[i],SELECT_BY_TICKET);
      double gfx.tp,gfx.sl;
      gfx.tp=NormalizeDouble(ObjectGet(tickets[i]+"-tp",OBJPROP_PRICE1),Digits);
      if(gfx.tp!=OrderTakeProfit()){
         if(gfx.tp!=tp[i]){
            if(OrderModify(OrderTicket(),OrderOpenPrice(),OrderStopLoss(),NormalizeDouble(gfx.tp,Digits),0,CLR_NONE)){
               tp[i]=gfx.tp;
               ObjectSet(tickets[i]+"-tp_l",OBJPROP_TIME1,OrderOpenTime());
               ObjectSet(tickets[i]+"-tp_l",OBJPROP_PRICE1,gfx.tp);
               ObjectSet(tickets[i]+"-tp_l",OBJPROP_COLOR,TakeprofitColor);  
               ObjectSetText(tickets[i]+"-tp_l","[TP]"+OrderTicket()+"  for "+DoubleToStr(MathAbs(OrderOpenPrice()-gfx.tp)/pmod,1)+" pips",Text_Size, TextFont);  

            }
         }else{
            ObjectSet(tickets[i]+"-tp",OBJPROP_PRICE1,OrderTakeProfit());
            ObjectSet(tickets[i]+"-tp_l",OBJPROP_TIME1,OrderOpenTime());
            ObjectSet(tickets[i]+"-tp_l",OBJPROP_PRICE1,OrderTakeProfit());
            ObjectSet(tickets[i]+"-tp_l",OBJPROP_COLOR,TakeprofitColor);  
            ObjectSetText(tickets[i]+"-tp_l","[TP]"+OrderTicket()+"  for "+DoubleToStr(MathAbs(OrderOpenPrice()-OrderTakeProfit())/pmod,1)+" pips",Text_Size, TextFont);  

            tp[i]=gfx.tp;               
         }
      }

      gfx.sl=NormalizeDouble(ObjectGet(tickets[i]+"-sl",OBJPROP_PRICE1),Digits);
      if(gfx.sl!=OrderStopLoss()){
         if(gfx.sl!=sl[i]){
            if(OrderModify(OrderTicket(),OrderOpenPrice(),NormalizeDouble(gfx.sl,Digits),OrderTakeProfit(),0,CLR_NONE)){
               sl[i]=gfx.sl;
               ObjectSet(tickets[i]+"-sl_l",OBJPROP_TIME1,OrderOpenTime());
               ObjectSet(tickets[i]+"-sl_l",OBJPROP_PRICE1,gfx.sl);
               ObjectSet(tickets[i]+"-sl_l",OBJPROP_COLOR,StoplossColor);  
               ObjectSetText(tickets[i]+"-sl_l","[SL]"+OrderTicket()+"  for "+DoubleToStr(MathAbs(OrderOpenPrice()-gfx.sl)/pmod,1)+" pips",Text_Size, TextFont);  

            }
         }else{
            ObjectSet(tickets[i]+"-sl",OBJPROP_PRICE1,OrderStopLoss());
            ObjectSet(tickets[i]+"-sl_l",OBJPROP_TIME1,OrderOpenTime());
            ObjectSet(tickets[i]+"-sl_l",OBJPROP_PRICE1,OrderStopLoss());
            ObjectSet(tickets[i]+"-sl_l",OBJPROP_COLOR,StoplossColor);  
            ObjectSetText(tickets[i]+"-sl_l","[SL]"+OrderTicket()+"  for "+DoubleToStr(MathAbs(OrderOpenPrice()-OrderStopLoss())/pmod,1)+" pips",Text_Size, TextFont);  

            sl[i]=gfx.sl;               
         }
      }

   }   
}



void OrderManager(int mode){
   static int tickets[];
   static double tp[];
   static double sl[];
   if(mode==MODE_DEINIT){
      DeleteGFX(tickets);
   }else{
      if(mode==MODE_INIT){
         ArrayResize(tickets,0);
      }
   
      int i=0;
      int OpenOrdersOnSymbol=0;
      for(i=OrdersTotal()-1;i>=0;i--){
         OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
         if(OrderSymbol()==Symbol()){
            OpenOrdersOnSymbol++;
         }
      }
      if(OpenOrdersOnSymbol!=ArraySize(tickets)){
         DeleteGFX(tickets);
         ArrayResize(tickets,OpenOrdersOnSymbol);
         ArrayResize(tp,OpenOrdersOnSymbol);
         ArrayResize(tp,OpenOrdersOnSymbol);
         int j=0;
         for(i=OrdersTotal()-1;i>=0;i--){
            OrderSelect(i,SELECT_BY_POS);
            if(OrderSymbol()==Symbol()){
               tickets[j]=OrderTicket();
               sl[j]=OrderStopLoss();
               tp[j]=OrderStopLoss();
               j++;
            }
         }
         UpdateGFX(tickets);
      }else{
         RecalcByGFX(tickets,tp,sl);
      }
   }
   Comment("NR of orders: "+ArraySize(tickets));
}

int init(){
   if(Digits==5||Digits==3){
      pmod=Point*10;
   }else{
      pmod=Point;
   }
   OrderManager(MODE_INIT);
   
   
   int hwnd = WindowHandle(Symbol(),0);
	ObjectSet("EASYORDER", OBJPROP_CORNER, BoxCorner);

	int ret = EasyOrder(hwnd);
	
	if(ret<0) 
   
   return(0);

}


int deinit(){
   OrderManager(MODE_DEINIT);
   return(0);
}
//+------------------------------------------------------------------+

